// i8088W_Basic_Info_Cplusplus.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include "..\Lib\pac_i8088W.h"
#pragma comment(lib,"..\\Lib\\pac_i8088W.lib")

int slot=-1;
int _tmain(int argc, _TCHAR* argv[])
{
	int i=0;
	char act=0;
	char sTemp[20];
	int ch = 0;
	unsigned long hz=0;
	unsigned int duty=0;
	int hw_en=0;
	int sync_en=0;
	int countMode = 0;  //1: Continuos ;0: Burst count
	unsigned int burstCount = 1000;
	unsigned int dival=0;
	int dibit[8];
	for(i=0;i<8;i++){
		//#1 "pac_i8088W_Init" must be called in the begining.
		if(pac_i8088W_Init(i)==0){
			slot=i;
			printf("There is an I-8088W at slot %d\n",slot);
			break;
		}
	}
	if(slot==-1){
		printf("There is no I-8088W at Backplane\n");
		getchar();
		exit(0);
	}
	while(1){
		printf("\nPlease configure I-8088W by following settings\n");
		printf("Press 'c' or 'C' to select the channel ro be set \n");
		printf("Press 'p' or 'P' to configure PWM \n");
		printf("Press 's' or 'S' to start output PWM \n");
		printf("Press 't' or 'T' to stop output PWM \n");
		printf("Press 'y' or 'Y' to set SYNC function \n");
		printf("Press 'e' or 'E' to start Synchronized PWM output \n");
		printf("Press 'n' or 'N' to start Synchronized PWM output \n");
		printf("Press 'd' or 'D' to read DI\n");
		printf("Press 'q' or 'Q' to exit\n");
		act=getchar();
		switch(act){
			case'c':case'C':{
				printf("Select channel\n");
				printf("('0' for channel 0,... '7' for channel 7,'8' for all channels)\n");
				scanf("%s",sTemp);
				ch=atoi(sTemp);
				break;
			}
			case'p':case'P':{
				printf("Set frequency(1 hz ~ 500000 hz)\n");
				scanf("%s",sTemp);
				hz=atol(sTemp);
				printf("Set duty(1 ~ 99)\n");
				scanf("%s",sTemp);
				duty=atoi(sTemp);
				if(ch==8){
					for(ch=0;ch<8;++ch){
						pac_i8088W_SetPWMDuty(slot,ch,hz,duty);
					}
				}
				else{
					pac_i8088W_SetPWMDuty(slot,ch,hz,duty);
				}
				
				printf("Set output mode(0 : Burst count ,1 : Continuos)\n");
				scanf("%s",sTemp);
				countMode=atoi(sTemp);
				if(countMode==0){
					printf("Set Burst count(1 ~ 65535)\n");
					scanf("%s",sTemp);
					burstCount=atoi(sTemp);
				}
				if(ch==8){
					for(ch=0;ch<8;++ch){
						pac_i8088W_SetPWMCountMode(slot,ch,countMode);
						pac_i8088W_SetBurstCount(slot,ch,burstCount);
					}
				}
				else{
					pac_i8088W_SetPWMCountMode(slot,ch,countMode);
					pac_i8088W_SetBurstCount(slot,ch,burstCount);
				}
				printf("Set Hardware Trigger(0 : disable ,1 : enable)\n");
				scanf("%s",sTemp);
				hw_en==atoi(sTemp);
				if(ch==8){
					for(ch=0;ch<8;++ch){
						pac_i8088W_SetHardwareTrigChannel(slot,ch,hw_en);
					}
				}
				else{
					pac_i8088W_SetHardwareTrigChannel(slot,ch,hw_en);
				}
				break;
			}
			case's':case'S':{
				if(ch==8){
					for(ch=0;ch<8;++ch){
						pac_i8088W_PWM_Start(slot,ch);
					}
				}
				else{
					pac_i8088W_PWM_Start(slot,ch);
				}
				break;
			}
			case't':case'T':{
				if(ch==8){
					for(ch=0;ch<8;++ch){
						pac_i8088W_PWM_Stop(slot,ch);
					}
				}
				else{
					pac_i8088W_PWM_Stop(slot,ch);
				}
				break;
			}
			case'y':case'Y':{
				printf("set the channels to be synchronized (0 : disable, 1 : enable)\n");
				scanf("%s",sTemp);
				sync_en=atoi(sTemp);
				if(ch==8){
					for(ch=0;ch<8;++ch){
						pac_i8088W_SetSyncChannel(slot,ch,sync_en);
					}
				}
				else{
					pac_i8088W_SetSyncChannel(slot,ch,sync_en);
				}
				break;
			}
			case'e':case'E':{
				pac_i8088W_Sync_Start(slot);
				break;
			}
			case'n':case'N':{
				pac_i8088W_Sync_Stop(slot);
				break;
			}
			case'd':case'D':{
				pac_i8088W_GetDI(slot,&dival,dibit);
				printf("DI sttatus : %02X \n",dival);
				break;
			}
			case'q':case'Q':{
				return 0;
				break;
			}
		}
	}
	return 0;
}