﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace i8088W_Basic_Info_Csharp
{
    public partial class Form1 : Form
    {
        int slot = 0;
        TextBox[] FREQ_txt;
        TextBox[] Duty_txt;
        ComboBox[] Mode_cmb;
        TextBox[] BurstCnt_txt;
        ComboBox[] HWTrigger_cmb;
        CheckBox[] SYNC_ckb;
        Label[] Status_lab;
        Label[] DI_lab;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i = 0;
            FREQ_txt = new TextBox[8] { C0_FREQ_txt, C1_FREQ_txt, C2_FREQ_txt, C3_FREQ_txt, C4_FREQ_txt, C5_FREQ_txt, C6_FREQ_txt, C7_FREQ_txt };
            Duty_txt = new TextBox[8] { C0_Duty_txt, C1_Duty_txt, C2_Duty_txt, C3_Duty_txt, C4_Duty_txt, C5_Duty_txt, C6_Duty_txt, C7_Duty_txt };
            Mode_cmb = new ComboBox[8] { C0_Mode_cmb, C1_Mode_cmb, C2_Mode_cmb, C3_Mode_cmb, C4_Mode_cmb, C5_Mode_cmb, C6_Mode_cmb, C7_Mode_cmb };
            BurstCnt_txt = new TextBox[8] { C0_BurstCnt_txt, C1_BurstCnt_txt, C2_BurstCnt_txt, C3_BurstCnt_txt, C4_BurstCnt_txt, C5_BurstCnt_txt, C6_BurstCnt_txt, C7_BurstCnt_txt };
            HWTrigger_cmb = new ComboBox[8] { C0_HWTrigger_cmb, C1_HWTrigger_cmb, C2_HWTrigger_cmb, C3_HWTrigger_cmb, C4_HWTrigger_cmb, C5_HWTrigger_cmb, C6_HWTrigger_cmb, C7_HWTrigger_cmb };
            SYNC_ckb = new CheckBox[8] { C0_SYNC_ckb, C1_SYNC_ckb, C2_SYNC_ckb, C3_SYNC_ckb, C4_SYNC_ckb, C5_SYNC_ckb, C6_SYNC_ckb, C7_SYNC_ckb };
            Status_lab = new Label[8] { C0_Status_lab, C1_Status_lab, C2_Status_lab, C3_Status_lab, C4_Status_lab, C5_Status_lab, C6_Status_lab, C7_Status_lab };
            DI_lab = new Label[8] { DI0_lab, DI1_lab, DI2_lab, DI3_lab, DI4_lab, DI5_lab, DI6_lab, DI7_lab };
            Slot_cmb.Items.Clear();
            for (i = 0; i < 8; ++i)
            {
                Slot_cmb.Items.Add(string.Format("Slot {0}", i));
            }
            for (i = 0; i < 8; ++i)
            {
                Mode_cmb[i].Items.Clear();
                Mode_cmb[i].Items.Add("Burst Count");
                Mode_cmb[i].Items.Add("Continuos");
                Mode_cmb[i].SelectedIndex = 0;
            }
            for (i = 0; i < 8; ++i)
            {
                HWTrigger_cmb[i].Items.Clear();
                HWTrigger_cmb[i].Items.Add("Disable");
                HWTrigger_cmb[i].Items.Add("Start");
                HWTrigger_cmb[i].Items.Add("Stop");
                HWTrigger_cmb[i].SelectedIndex = 0;
            }
        }

        private void Slot_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (pac8088WNet.pac8088W.Init(Slot_cmb.SelectedIndex) == 0)
            {
                slot = Slot_cmb.SelectedIndex;
                Libver_txt.Text = String.Format("{0:X4}", pac8088WNet.pac8088W.LibVersion());
                Libdate_txt.Text = pac8088WNet.pac8088W.LibDate();
                HW_FW_txt.Text = String.Format("{0:X4}", pac8088WNet.pac8088W.FirmwareVersion(slot));
            }
            else
            {
                MessageBox.Show(String.Format("No I-8088W at slot {0}", Slot_cmb.SelectedIndex));
            }
        }

        private void C0_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 0;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            pac8088WNet.pac8088W.SetHardwareTrigChannel(slot, ch, HWTrigger_cmb[ch].SelectedIndex);
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C1_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 1;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            pac8088WNet.pac8088W.SetHardwareTrigChannel(slot, ch, HWTrigger_cmb[ch].SelectedIndex);
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C2_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 2;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            pac8088WNet.pac8088W.SetHardwareTrigChannel(slot, ch, HWTrigger_cmb[ch].SelectedIndex);
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C3_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 3;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            pac8088WNet.pac8088W.SetHardwareTrigChannel(slot, ch, HWTrigger_cmb[ch].SelectedIndex);
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C4_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 4;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            pac8088WNet.pac8088W.SetHardwareTrigChannel(slot, ch, HWTrigger_cmb[ch].SelectedIndex);
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C5_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 5;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            pac8088WNet.pac8088W.SetHardwareTrigChannel(slot, ch, HWTrigger_cmb[ch].SelectedIndex);
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C6_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 6;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            pac8088WNet.pac8088W.SetHardwareTrigChannel(slot, ch, HWTrigger_cmb[ch].SelectedIndex);
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C7_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 7;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            pac8088WNet.pac8088W.SetHardwareTrigChannel(slot, ch, HWTrigger_cmb[ch].SelectedIndex);
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C0_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 0;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C1_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 1;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C2_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 2;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C3_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 3;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C4_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 4;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C5_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 5;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C6_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 6;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C7_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 7;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void Sync_Start_Stop_btn_Click(object sender, EventArgs e)
        {
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.Sync_Start(slot);
            }
            else if (((Button)sender).Text == "Stop")
            {
                pac8088WNet.pac8088W.Sync_Stop(slot);
                ((Button)sender).Text = "Start";
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int i = 0;
            Int32 pwmStatus = 0;
            Int32[] pwmBitArr = new Int32[8];
            int diVal = 0;
            int[] diBit = new int[8];
            if (slot != -1)
            {
                pac8088WNet.pac8088W.GetDI(slot, ref diVal, diBit);
                for (i = 0; i < 8; i++)
                {
                    if (diBit[i] == 1)
                    {
                        DI_lab[i].Text = "ON";
                    }
                    else
                    {
                        DI_lab[i].Text = "OFF";
                    }
                }
                pac8088WNet.pac8088W.GetPWMActiveState(slot, ref pwmStatus, pwmBitArr);
                for (i = 0; i < 8; i++)
                {
                    if (pwmBitArr[i] == 1)
                    {
                        Status_lab[i].Text = "ON";
                    }
                    else
                    {
                        Status_lab[i].Text = "OFF";
                    }
                }
            }
        }

        private void Exit_btn_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
