﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace i9088_Basic_Info_Csharp
{
    public partial class Form1 : Form
    {
        int slot = 0;
        TextBox[] FREQ_txt;
        TextBox[] Duty_txt;
        ComboBox[] Mode_cmb;
        TextBox[] BurstCnt_txt;
        CheckBox[] SYNC_ckb;
        Label[] Status_lab;
        Label[] DI_lab;
        bool refresh_wdt = false;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i = 0;
            FREQ_txt = new TextBox[16] { 
                C0_FREQ_txt, C1_FREQ_txt, C2_FREQ_txt, C3_FREQ_txt, C4_FREQ_txt, C5_FREQ_txt, C6_FREQ_txt, C7_FREQ_txt,
                C8_FREQ_txt, C9_FREQ_txt, C10_FREQ_txt, C11_FREQ_txt, C12_FREQ_txt, C13_FREQ_txt, C14_FREQ_txt, C15_FREQ_txt
            };
            Duty_txt = new TextBox[16] { 
                C0_Duty_txt, C1_Duty_txt, C2_Duty_txt, C3_Duty_txt, C4_Duty_txt, C5_Duty_txt, C6_Duty_txt, C7_Duty_txt,
                C8_Duty_txt, C9_Duty_txt, C10_Duty_txt, C11_Duty_txt, C12_Duty_txt, C13_Duty_txt, C14_Duty_txt, C15_Duty_txt
            };
            Mode_cmb = new ComboBox[16] { 
                C0_Mode_cmb, C1_Mode_cmb, C2_Mode_cmb, C3_Mode_cmb, C4_Mode_cmb, C5_Mode_cmb, C6_Mode_cmb, C7_Mode_cmb,
                C8_Mode_cmb, C9_Mode_cmb, C10_Mode_cmb, C11_Mode_cmb, C12_Mode_cmb, C13_Mode_cmb, C14_Mode_cmb, C15_Mode_cmb
            };
            BurstCnt_txt = new TextBox[16] { 
                C0_BurstCnt_txt, C1_BurstCnt_txt, C2_BurstCnt_txt, C3_BurstCnt_txt, C4_BurstCnt_txt, C5_BurstCnt_txt, C6_BurstCnt_txt, C7_BurstCnt_txt, 
                C8_BurstCnt_txt, C9_BurstCnt_txt, C10_BurstCnt_txt, C11_BurstCnt_txt, C12_BurstCnt_txt, C13_BurstCnt_txt, C14_BurstCnt_txt, C15_BurstCnt_txt 
            };
            SYNC_ckb = new CheckBox[16] { 
                C0_SYNC_ckb, C1_SYNC_ckb, C2_SYNC_ckb, C3_SYNC_ckb, C4_SYNC_ckb, C5_SYNC_ckb, C6_SYNC_ckb, C7_SYNC_ckb,
                C8_SYNC_ckb, C9_SYNC_ckb, C10_SYNC_ckb, C11_SYNC_ckb, C12_SYNC_ckb, C13_SYNC_ckb, C14_SYNC_ckb, C15_SYNC_ckb
            };
            Status_lab = new Label[16] { 
                C0_Status_lab, C1_Status_lab, C2_Status_lab, C3_Status_lab, C4_Status_lab, C5_Status_lab, C6_Status_lab, C7_Status_lab,
                C8_Status_lab, C9_Status_lab, C10_Status_lab, C11_Status_lab, C12_Status_lab, C13_Status_lab, C14_Status_lab, C15_Status_lab
            };
            DI_lab = new Label[8] { DI0_lab, DI1_lab, DI2_lab, DI3_lab, DI4_lab, DI5_lab, DI6_lab, DI7_lab };
            Slot_cmb.Items.Clear();
            for (i = 0; i < 8; ++i)
            {
                Slot_cmb.Items.Add(string.Format("Slot {0}", i));
            }
            for (i = 0; i < 16; ++i)
            {
                Mode_cmb[i].Items.Clear();
                Mode_cmb[i].Items.Add("Burst Count");
                Mode_cmb[i].Items.Add("Continuos");
                Mode_cmb[i].SelectedIndex = 1;
            }
            PO_Mode_cmb.Items.Clear();
            PO_Mode_cmb.Items.Add("Disable");
            PO_Mode_cmb.Items.Add("Power On Value");
        }

        private void Slot_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (pac8088WNet.pac8088W.Init(Slot_cmb.SelectedIndex) == 0)
            {
                slot = Slot_cmb.SelectedIndex;
                Libver_txt.Text = String.Format("{0:X4}", pac8088WNet.pac8088W.LibVersion());
                Libdate_txt.Text = pac8088WNet.pac8088W.LibDate();
                HW_FW_txt.Text = String.Format("{0:X4}", pac8088WNet.pac8088W.FirmwareVersion(slot));
            }
            else
            {
                MessageBox.Show(String.Format("No I-8088W at slot {0}", Slot_cmb.SelectedIndex));
            }
        }

        private void C0_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 0;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C1_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 1;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C2_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 2;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C3_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 3;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C4_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 4;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C5_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 5;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C6_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 6;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C7_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 7;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C8_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 8;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C9_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 9;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C10_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 10;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C11_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 11;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C12_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 12;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C13_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 13;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C14_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 14;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C15_Set_btn_Click(object sender, EventArgs e)
        {
            int ch = 15;
            pac8088WNet.pac8088W.SetPWMDuty(slot, ch, UInt32.Parse(FREQ_txt[ch].Text), UInt16.Parse(Duty_txt[ch].Text));
            pac8088WNet.pac8088W.SetPWMCountMode(slot, ch, (byte)Mode_cmb[ch].SelectedIndex);
            pac8088WNet.pac8088W.SetBurstCount(slot, ch, UInt16.Parse(BurstCnt_txt[ch].Text));
            if (SYNC_ckb[ch].Checked)
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 1);
            }
            else
            {
                pac8088WNet.pac8088W.SetSyncChannel(slot, ch, 0);
            }
        }

        private void C0_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 0;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C1_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 1;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C2_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 2;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C3_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 3;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C4_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 4;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C5_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 5;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C6_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 6;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C7_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 7;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C8_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 8;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C9_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 9;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C10_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 10;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C11_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 11;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C12_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 12;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C13_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 13;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C14_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 14;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void C15_Start_btn_Click(object sender, EventArgs e)
        {
            int ch = 15;
            if (((Button)sender).Text == "Start")
            {
                ((Button)sender).Text = "Stop";
                pac8088WNet.pac8088W.PWM_Start(slot, ch);
            }
            else if (((Button)sender).Text == "Stop")
            {
                ((Button)sender).Text = "Start";
                pac8088WNet.pac8088W.PWM_Stop(slot, ch);
            }
        }

        private void Sync_Start_Stop_btn_Click(object sender, EventArgs e)
        {
            if (((Button)sender).Text == "SYNC Start")
            {
                ((Button)sender).Text = "SYNC Stop";
                pac8088WNet.pac8088W.Sync_Start(slot);
            }
            else if (((Button)sender).Text == "SYNC Stop")
            {
                pac8088WNet.pac8088W.Sync_Stop(slot);
                ((Button)sender).Text = "SYNC Start";
            }
        }

        private void Get_PWM_Status_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            Int32 pwmStatus = 0;
            Int32[] pwmBitArr = new Int32[16];
            pac8088WNet.pac8088W.GetPWMActiveState(slot, ref pwmStatus, pwmBitArr);
            for (i = 0; i < 16; i++)
            {
                if (pwmBitArr[i] == 1)
                {
                    Status_lab[i].Text = "ON";
                }
                else
                {
                    Status_lab[i].Text = "OFF";
                }
            }
        }

        private void PO_Set_btn_Click(object sender, EventArgs e)
        {
            pac8088WNet.pac8088W.SetPowerOnMode(slot, (short)PO_Mode_cmb.SelectedIndex);
            pac8088WNet.pac8088W.WritePowerOnValue(slot, Convert.ToUInt16(PO_Val_txt.Text, 16));
        }

        private void Safe_Set_btn_Click(object sender, EventArgs e)
        {
            short en = 0;
            int overwrite = 0;
            pac8088WNet.pac8088W.WriteSafeValue(slot, Convert.ToUInt16(Safe_Val_txt.Text, 16));
            if (Safe_EN_ckb.Checked == true)
            {
                en = 1;
            }
            else
            {
                en = 0;
            }
            if (Safe_overwrite_ckb.Checked == true)
            {
                overwrite = 1;
            }
            else
            {
                overwrite = 0;
            }
            pac8088WNet.pac8088W.SetModuleWDTConfig(slot, en, ushort.Parse(WDT_txt.Text), overwrite);
        }

        private void Start_Stop_Refresh_btn_Click(object sender, EventArgs e)
        {
            if (Start_Stop_Refresh_btn.Text == "Start Refresh WDT")
            {
                refresh_wdt = true;
                Start_Stop_Refresh_btn.Text = "Stop Refresh WDT";
                RefreshWDT();
            }
            else if (Start_Stop_Refresh_btn.Text == "Stop Refresh WDT")
            {
                refresh_wdt = false;
                Start_Stop_Refresh_btn.Text = "Start Refresh WDT";
            }

        }
        void RefreshWDT()
        {
            while (refresh_wdt)
            {
                pac8088WNet.pac8088W.RefreshModuleWDT(slot);
                Thread.Sleep(100);
                Application.DoEvents();
            }
        }

        private void Reset_btn_Click(object sender, EventArgs e)
        {
            pac8088WNet.pac8088W.ResetModuleWDT(slot);
        }

        private void LPF_Set_btn_Click(object sender, EventArgs e)
        {
            pac8088WNet.pac8088W.SetLowPassFilter(slot, int.Parse(LPF_txt.Text));
        }

        private void Read_DI_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            int dival = 0;
            int[] dibit = new int[8];
            pac8088WNet.pac8088W.GetDI(slot, ref dival, dibit);
            for (i = 0; i < 8; ++i)
            {
                if (dibit[i] == 1)
                {
                    DI_lab[i].Text = "ON";
                }
                else
                {
                    DI_lab[i].Text = "OFF";
                }
            }
        }

        private void Exit_btn_Click(object sender, EventArgs e)
        {
            refresh_wdt = false;
            Close();
        }
    }
}
